/**************************************************************************
 Copyright (c) 2000-2001, Tony Garnock-Jones
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:

     * Redistributions of source code must retain the above copyright
       notice, this list of conditions and the following disclaimer.

     * Redistributions in binary form must reproduce the above
       copyright notice, this list of conditions and the following
       disclaimer in the documentation and/or other materials provided
       with the distribution.

     * Neither the names of the copyright holders nor the names of this
       software's contributors may be used to endorse or promote
       products derived from this software without specific prior
       written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR
 CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**************************************************************************/

/* -*- c++ -*- */
#ifndef MPS_H
#define MPS_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>

#include <string>
#include <vector>
#include <map>

///////////////////////////////////////////////////////////////////////////

#include <mps/ref.h>
#include <mps/exception.h>

#include <mps/interface.h>
#include <mps/stream.h>
#include <mps/address.h>
#include <mps/connection.h>

#include <mps/proxy.h>
#include <mps/server.h>

#include <mps/transport.h>

///////////////////////////////////////////////////////////////////////////

#include <mps/mpsnaming.h>

namespace MPS {
typedef org::hebe::mps::naming::NamingService NamingService;
typedef org::hebe::mps::naming::Result NamingResult;
}

#ifdef __WIN32__
extern "C" {
  extern char *MPS_optarg;
  extern int MPS_optind;
  extern int MPS_opterr;
  extern int MPS_optopt;
  extern int MPS_getopt(int argc, char *argv[], char *optspec);
};
#else
#define MPS_optarg optarg
#define MPS_optind optind
#define MPS_opterr opterr
#define MPS_optopt optopt
#define MPS_getopt getopt
#endif

#endif
