// Auto-generated by mpsidl
#ifndef MPS_mpsnaming_H
#define MPS_mpsnaming_H

#include <string>
#include <vector>

#include <mps/mps.h>
#include <mps/mpsnaming.h>

namespace org {
namespace hebe {
namespace mps {
namespace naming {
class Result {
public:
    Result() {}
    Result(
        bool bound,
        string const& objectName,
        string const& resolvedName)
    {
        this->bound = bound;
        this->objectName = objectName;
        this->resolvedName = resolvedName;
    }

    Result(MPS::InputStream &__input) {
        bool __sym0 = __input.readbool();
        bound = __sym0;
        string __sym1 = __input.readstring();
        objectName = __sym1;
        string __sym2 = __input.readstring();
        resolvedName = __sym2;
    }

    void __writeTo(MPS::OutputStream &__output) const {
        __output.writebool(bound);
        __output.writestring(objectName);
        __output.writestring(resolvedName);
    }

private:
    bool bound;
    string objectName;
    string resolvedName;

public:
    bool get_bound() { return bound; }
    string get_objectName() { return objectName; }
    string get_resolvedName() { return resolvedName; }

};

class NamingService: public MPS::Interface {
public:
    static ref<NamingService> _attach(string const &objectName);

    virtual org::hebe::mps::naming::Result resolve(
        string const& objectName) = 0;
    virtual org::hebe::mps::naming::Result bind(
        string const& objectName,
        string const& resolvedName,
        bool replace) = 0;
    virtual bool unbind(
        string const& objectName) = 0;
    virtual vector< org::hebe::mps::naming::Result > enumerate() = 0;
};

class NamingServiceProxy: public MPS::Proxy, public NamingService {
public:
    virtual string _getResolvedName() const {
        return MPS::Proxy::_connection->getRemoteAddress().getResolvedName();
    }

    NamingServiceProxy(string const &objectName)
        : MPS::Proxy(objectName)
    {}

    virtual ~NamingServiceProxy() {}

    void _send_resolve(
        string const& objectName);
    org::hebe::mps::naming::Result _decode_resolve(MPS::InputStream &__input);

    virtual org::hebe::mps::naming::Result resolve(
        string const& objectName) {
        _send_resolve(
            objectName);
        MPS::InputStream *__input = MPS::Proxy::_connection->getInputStream();
        try {
            org::hebe::mps::naming::Result __result = _decode_resolve(*__input);
            MPS::Proxy::_connection->releaseInputStream(__input);
            return __result;
        } catch (...) {
            MPS::Proxy::_connection->releaseInputStream(__input);
            throw;
        }
    }

    void _send_bind(
        string const& objectName,
        string const& resolvedName,
        bool replace);
    org::hebe::mps::naming::Result _decode_bind(MPS::InputStream &__input);

    virtual org::hebe::mps::naming::Result bind(
        string const& objectName,
        string const& resolvedName,
        bool replace) {
        _send_bind(
            objectName,
            resolvedName,
            replace);
        MPS::InputStream *__input = MPS::Proxy::_connection->getInputStream();
        try {
            org::hebe::mps::naming::Result __result = _decode_bind(*__input);
            MPS::Proxy::_connection->releaseInputStream(__input);
            return __result;
        } catch (...) {
            MPS::Proxy::_connection->releaseInputStream(__input);
            throw;
        }
    }

    void _send_unbind(
        string const& objectName);
    bool _decode_unbind(MPS::InputStream &__input);

    virtual bool unbind(
        string const& objectName) {
        _send_unbind(
            objectName);
        MPS::InputStream *__input = MPS::Proxy::_connection->getInputStream();
        try {
            bool __result = _decode_unbind(*__input);
            MPS::Proxy::_connection->releaseInputStream(__input);
            return __result;
        } catch (...) {
            MPS::Proxy::_connection->releaseInputStream(__input);
            throw;
        }
    }

    void _send_enumerate();
    vector< org::hebe::mps::naming::Result > _decode_enumerate(MPS::InputStream &__input);

    virtual vector< org::hebe::mps::naming::Result > enumerate() {
        _send_enumerate();
        MPS::InputStream *__input = MPS::Proxy::_connection->getInputStream();
        try {
            vector< org::hebe::mps::naming::Result > __result = _decode_enumerate(*__input);
            MPS::Proxy::_connection->releaseInputStream(__input);
            return __result;
        } catch (...) {
            MPS::Proxy::_connection->releaseInputStream(__input);
            throw;
        }
    }

};

class NamingServiceServer: public MPS::InterfaceServer {
public:
    NamingServiceServer(string const &objectName,
             ref<NamingService> const &impl)
        : MPS::InterfaceServer(objectName, impl)
    {
        setupMethods();
    }

private:
    void setupMethods();
    static void do_resolve(ref<MPS::Interface> const &__impl_base,
                      MPS::InputStream &__input,
                      MPS::OutputStream &__output);
    static void do_bind(ref<MPS::Interface> const &__impl_base,
                      MPS::InputStream &__input,
                      MPS::OutputStream &__output);
    static void do_unbind(ref<MPS::Interface> const &__impl_base,
                      MPS::InputStream &__input,
                      MPS::OutputStream &__output);
    static void do_enumerate(ref<MPS::Interface> const &__impl_base,
                      MPS::InputStream &__input,
                      MPS::OutputStream &__output);
};

} // end namespace naming
} // end namespace mps
} // end namespace hebe
} // end namespace org
#endif
